package jdwangPackage;
use Data::Dumper;
use FileHandle;
#####################################################################
# 2007.2.7
#####################################################################
sub DirFilenames {
	local ($SrcDir,$SegFileAry) = @_;
	
	opendir (DIRHandle,$SrcDir) or die "Can't open directory=>$SrcDir";
	
	
	#my @SegFileAry = ();
	while (my $OneFileName = readdir DIRHandle)
	{
		
	  if ($OneFileName =~ /^\./)
	  {  	 
	  	# skip the "." and ".."
	  } else {
	  	#print "Directory=>$OneFileName\n";
		push (@$SegFileAry,$OneFileName);
	  }	
	}
	
	closedir DIRHandle;
	@$SegFileAry = sort @$SegFileAry;
	
	return($#$SegFileAry+1);
}
#####################################################################
# 2007.2.7
#####################################################################
sub SeqTypesInfo {
	my ($SeqTypesFile,$ClassFileName) = @_;
	open (FILEHANDLE, $SeqTypesFile) or die "can't not open $SeqTypesFile";
	
	while (my $OneClassFile = <FILEHANDLE>)
	{
		if ($OneClassFile =~ /^#/)
		{
			if ($OneClassFile =~ /^#SrcDir/) {
			  my ($SrcDir) = $OneClassFile =~ /^#SrcDir#(.+)/;
			}
			
		} else {		
			#1#Bromoviridae.txt#12#100755
			$OneClassFile =~ s/\s+//g;  # remove space 
			my @SeqFileName = split /#/, $OneClassFile;
			#my @Items = $SeqFileName[1] =~ /^(\w+)\.(\w+)/g;
			my $SeqType = $SeqFileName[1];
			#print "ClassID:".$SeqFileName[0]."=>".$SeqFileName[1]."=>".$SeqFileName[2]."\n";
			my $SeqRecord = {'ClassType'=>$SeqType,
			                 'ClassID'=>$SeqFileName[0],
			                 'FileName'=>$SeqFileName[1],
			                 'SeqCnt'=>$SeqFileName[2],
			                 'SeqTotalLength'=>$SeqFileName[3]};	
			push (@$ClassFileName,$SeqRecord); 
		}
	} # end of while 
	close(FILEHANDLE);
	#my $ClassNum = $#$ClassFileName+1;
	#print "Number of Classes : $ClassNum\n";
	return($#$ClassFileName+1);
}
#####################################################################
# 2007.2.7
#####################################################################
sub SeqStartLine {
	my ($InputFile,$StartLineMark,$SeqStartLine) = @_;	
	open (FILEHANDLE, "<$InputFile") or die " can't not open $InputFile";
	#print "$InputFile\n";
	#print "$StartLineMark\n";
	my $LineCnt = 0;
	my $SeqCnt = 0;
	while (my $line = <FILEHANDLE>)
	{
		$LineCnt++;
		if ($line =~ /$StartLineMark/) {
	  		push @$SeqStartLine,$LineCnt;
	  		$SeqCnt++;
		} 
	} # end of while 
	push @$SeqStartLine, $LineCnt+1; # mark the last line
	close (FILEHANDLE);
	return($SeqCnt);
}	
#####################################################################
# 2007.2.12
#####################################################################
sub LoadClassIDMap {
	my ($MappingClassIDFile,$TargetIDMapping) = @_;
	
	open (FileHandle, "<$MappingClassIDFile") or die "LoadClassIDMap:can't open $MappingClassIDFile";
	my $FieldNames = <FileHandle>;
	my $TargetIDCnt = 0;
	#my $TargetIDMapping = {};
	
	while (my $Line = <FileHandle>) {	
		#SegVectorDir#?
		#NumOfSeqType#?
		#NumOfTargetID#?
		#print $Line."\n";
		#print $Line;
		if ($Line =~ /^#/) {
			
		}
		else {
			# Comments
			#Centroid TargetID
			#Centroid_1.txt 1
			#Centroid_2.txt 2
			$TargetIDCnt++;
			chomp($Line);
			my @Items = split / /, $Line;
			my $TargetID = $Items[0];
			my $SeqType = $Items[1];
			$TargetIDMapping->{$SeqType} = $TargetID;	
			#print "$TargetID $SeqType\n";
		}
	} # end of while (my $Line = <InputFileHandle>) {
	close(FileHandle);
	#print Dumper($TargetIDMapping);exit;
	#print "\nPass reading $TargetIDCnt =>$MappingClassIDFile\n";
	return($TargetIDCnt);
}
#####################################################################
# 2007.2.12
#####################################################################
sub SumUpSeqVectorInOneFile {
	my ($SeqVectorFile,$SeqType,$SeqVectors,$MappingClassID,$PatternWeight) = @_;
	#my $fh = new FileHandle($SeqVectorFile,"r");
	open (input,"<$SeqVectorFile") or die "can't open $SeqVectorFile";
	my $SeqVectorCnt = 0;
	#while (my $line = <$fh>)
	while (my $line = <input>)
	{
		if ($line =~ /^#/ ) {
			# skip information lines
		} else {
			$SeqVectorCnt++;
			#SeqID NumHits##PID wtf Weight#PID wtf Weight#PID wtf Weight#...
			#1 16##1 204 0.256032#10 148 0.180441#11 139 0.171783#12 198 0.231547#13 143 0.168553#14 259 0.301168#15 287 0.346739#16 231 0.264029#2 192 0.233738#3 200 0.244401#4 245 0.294332#5 304 0.370758#6 146 0.173724#7 49 0.058966#8 247 0.287685#9 190 0.234171#
		    #my $NumHits;
			my @Items = split /##/, $line;
		    my ($SID, $NumHits) = $Items[0] =~ /^(.+) (\d+)/;
		    #print Dumper($Items[0]);
		    chomp($Items[1]);
		    my @OneVector = split /#/, $Items[1];
		    if ($NumHits == ($#OneVector+1)) {
		    	#print Dumper(@OneVector);
		    	foreach my $Dim (@OneVector) {
		    		my ($PID,$Wtf) = split / /, $Dim;
		    		$SeqVectors->{$MappingClassID->{$SeqType}}->{$PID} += $Wtf*$PatternWeight->{$PID}; 
				}
			} else {
				print "Error Vector Dimension! $NumHits == ($#OneVector+1))";
				exit;
			}
		} # end of if ($line =~ /^#/ ) {
	} # end of while (my $line = <input>)
	close(input);
	#$fh->close;
	#print Dumper($SeqVectors); exit;
	return($SeqVectorCnt);
}	
#####################################################################
# 2007.2.12
#####################################################################
sub LoadSeqVectorInOneFile {
	my ($fh,$SeqType,$SeqVectors,$MappingClassID) = @_;
	
	my $SeqVectorCnt = 0;
	while (my $line = <$fh>)
	{
		if ($line =~ /^#/ ) {
			# skip information lines
		} else {
			$SeqVectorCnt++;
			#SeqID NumHits##PID wtf Weight#PID wtf Weight#PID wtf Weight#...
			#1 16##1 204 0.256032#10 148 0.180441#11 139 0.171783#12 198 0.231547#13 143 0.168553#14 259 0.301168#15 287 0.346739#16 231 0.264029#2 192 0.233738#3 200 0.244401#4 245 0.294332#5 304 0.370758#6 146 0.173724#7 49 0.058966#8 247 0.287685#9 190 0.234171#
		    #my $NumHits;
			my @Items = split /##/, $line;
		    my ($SID, $NumHits) = $Items[0] =~ /^(.+) (\d+)/;
		    #print Dumper($Items[0]);
		    chomp($Items[1]);
		    my @OneVector = split /#/, $Items[1];
		    if ($NumHits == ($#OneVector+1)) {
		    	#print Dumper(@OneVector);
		    	foreach my $Dim (@OneVector) {
		    		my ($PID,$Wtf,$Weight) = split / /, $Dim;
		    		$SeqVectors->{$MappingClassID->{$SeqType}}->{$PID} += $Weight; 
				}
			} else {
				print "Error Vector Dimension! $NumHits == ($#OneVector+1))";
				exit;
			}
		} # end of if ($line =~ /^#/ ) {
	} # end of while (my $line = <input>)
	close(input);
	return($SeqVectorCnt);
}	
#####################################################################
# 2007.2.12
#####################################################################
sub LoadPatternWeight{
	my ($SourceFile,$WeightingMethod,$Patterns) = @_;
	#my $Patterns = {};
	my $cnt=0;
	open InputHandle, $SourceFile or die "Can't open $SourceFile";
	while (my $line = <InputHandle>) {
		if ($line =~ /^#/) {
			# fielnames
			print Output $line;
		} else {
			$cnt++;
		    my @items = split / /, $line;
		    #print Dumper(@items);exit;
		    $Patterns->{$items[0]} = $items[$WeightingMethod];
		} # end of if ($Line =~ /^#/) {
	}   
	#print Dumper($Patterns);exit;
	close(InputHandle);
	return($cnt);
}
#####################################################################
# 2007.2.12
#####################################################################
sub LoadETA{
	my ($ETAFile,$ETA) = @_;	
	
	my $cnt=0;
	open InputHandle, $ETAFile or die "Can't open $ETAFile";
	
	@$ETA = <InputHandle>;
	#$ETA#while (my $line = <InputHandle>) {
		 #print "$line\n";
	#	 $ETA->[$cnt] = chomp($line);
	#	 $cnt++;
	#}   
	#print Dumper($ETA);exit;
	close(InputHandle);
}
#####################################################################
# 2007.3.1
#####################################################################
sub VectorNormalization{
	my ($Vector) = @_;
	my $sum = 0;
	foreach $dim (keys %$Vector) {
		#print Dumper($Vector->{$dim});exit;
		$sum += $Vector->{$dim}*$Vector->{$dim};
	}	
	my $length = sqrt($sum);
	foreach $dim (keys %$Vector) {
		$Vector->{$dim} = $Vector->{$dim}/$length;
	}
	#print Dumper($Vector);exit;
}
#####################################################################
# 2007.3.1
#####################################################################
sub LoadInfo{
	my ($InfoFile,$Info) = @_;
	open (input,"<$InfoFile") or die "can't open $InfoFile";

	while (my $line = <input>) {
		#print $line;
		if ($line =~ /^#/) {
			my ($info) = $line =~ /#(.+)/;
			chomp($line);
			my @items = split /##/, $info;
			#print Dumper(@items);exit;
			if (($items[0] =~ /^TrainDir/) || ($items[0] =~ /^ETAResultDir/))
			{
				my @Dirs = split  / /,$items[1];
				$Info->{$items[0]}->{$Dirs[0]} = $Dirs[1];
			} else {
				$Info->{$items[0]} = $items[1];
			}
		}
	} # end of while (my $line = <input>)
}
#####################################################################
# 2007.3.3
#####################################################################
sub LoadClassifiersMapping {
	my ($ClassifierMappingLocation,$ClassifierMapping) = @_;
	my $cnt=0;
	open (input, "<$ClassifierMappingLocation") or die "can't open $ClassifierMappingLocation";
	while (my $line = <input>) {
		if ($line =~ /^#/) {
			# comments
			#print $line;
		} else {
			chomp($line);
		    my @items = split / /, $line;
		    #print Dumper(@items);exit;
		    if ($#items != 0) {
		    	$ClassifierMapping->{$items[0]} = $items[1];
		    	$cnt++;
	    	}
		} # end of if ($Line =~ /^#/) {
	}   
	#print Dumper($ClassifierMapping);exit;
	close(input);
	return($cnt);
}	
#####################################################################
# 2007.3.4
#####################################################################
sub LoadClassifiers {
	my ($ClassifierDirLocation,$Classifiers) = @_;
	my @ClassifierCentroidFile = ();
	my $ClassifierCnt = DirFilenames ($ClassifierDirLocation,\@ClassifierCentroidFile);
	#print Dumper(@ClassifierCentroidFile);
	#print Dumper($ClassifierCnt);exit;
	foreach my $FileName ( @ClassifierCentroidFile) {
		my ($ClassifiersName,$ext) = $FileName =~ /^(\w+)(\.\w+)?/g; 
		
		my $OneClassifierFile = $ClassifierDirLocation."\/".$FileName;
		
		open (input,"<$OneClassifierFile") or die "can't open $OneClassifierFile ";
		
		while (my $line = <input>) {
			if ($line =~ /^#/) {
				
			} else {
				chomp($line);
				my @items = split / /,$line;
				$Classifiers->{$ClassifiersName}->{$items[0]} = $items[1];
			}
		} # end of while (my $line = <input>) {
	} # end of foreach my $FileName ( @ClassifierCentroidFile) {
 	#print Dumper($Classifiers);exit;
}
#####################################################################
# 2007.3.4
#####################################################################
sub LoadOneClassifier {
	my ($ClassifierLocation,$Classifiers) = @_;
	
	#print Dumper($ClassifiersName);exit;
			
	open (input,"<$ClassifierLocation") or die "can't open $ClassifierLocation\n";
		
	while (my $line = <input>) {
			if ($line =~ /^#/) {
				
			} else {
				chomp($line);
				my @items = split / /,$line;
				$Classifiers->{$items[0]} = $items[1];
			}
	} # end of while (my $line = <input>) {
 	#print Dumper($Classifiers);exit;
}
#####################################################################
# 2007.3.5
#####################################################################
sub LoadTestVector {
	my ($TestVectorsFile,$TestVectors,$PatternWeight) = @_;
	#print Dumper($PatternWeight);exit;
	my $cnt=0;
	open (input, "<$TestVectorsFile") or die "can't open $TestVectorsFile";
	while (my $line = <input>) {
		if ($line =~ /^#/) {
			# comments
			#print $line;
		} else {
			chomp($line);
		    my @items = split /##/,$line;
		    if ($#items != 0) {
		    	$cnt++;
			    my ($TestID,$MatchCnt) = split / /,$items[0];
			    my @Vector = split /#/, $items[1];
			    foreach my $OneDimInfo (@Vector) {
				    my ($PID,$wtf) = split / /,$OneDimInfo;
				    $TestVectors->{$TestID}->{$PID} = $wtf*$PatternWeight->{$PID};
			    }
			    jdwangPackage::VectorNormalization($TestVectors->{$TestID});
			} # end of if ($#items != 0) {
			#print Dumper($TestVectors);exit;
		} # end of if ($Line =~ /^#/) {
	}   
	#print Dumper($ClassifierMapping);exit;
	close(input);
	return($cnt);
}
#####################################################################
# 2007.3.5
#####################################################################
sub CosineSimilarity {
	my ($TestVectors,$Classifiers) = @_;
	my $CosSim = 0;
	foreach my $PID (keys %$TestVectors) {
		$CosSim += $TestVectors->{$PID}*$Classifiers->{$PID};	
	}
	return($CosSim);
}
#####################################################################
# 2007.3.5
#####################################################################
sub FindMax {
	my ($CosSim_Classifier) = @_;
	my $Sim = 0;
	my $MaxClassifier;
	foreach my $OneClassifier (keys %{$CosSim_Classifier}) {
		if ($CosSim_Classifier->{$OneClassifier} > $Sim) {
			$MaxClassifier = $OneClassifier;
			$Sim = $CosSim_Classifier->{$OneClassifier};
		}
	}
	return($MaxClassifier);
}
#####################################################################
# 2007.3.7
#####################################################################
sub SortHash_Num {
  local( $Testhash, $SortList ) = @_;

  @{$SortList} = sort {$Testhash->{$b} <=> $Testhash->{$a}} keys %{$Testhash};
}
#####################################################################
# 2007.3.7
#####################################################################
sub SortHash_Str {
  local( $Testhash, $SortList ) = @_;

  @{$SortList} = sort {$Testhash->{$b} cmp $Testhash->{$a}} keys %{$Testhash};
}
#####################################################################
# 2007.3.12
#####################################################################
sub CreatClassifier {
	
	my ($TestInfo,$ETA,$SeqVectors,$SeqVectorCnt) = @_;
	
	#print Dumper($TestInfo);exit;
	
	my $ClassifierDir =  $TestInfo->{"ClassifiersDir"};
	my $ETAFile = $TestInfo->{"ETAFile"};
	my $PatternWeightFile = $TestInfo->{"PatternsWeighting"};
	my $WeightingMethod = $TestInfo->{"WM"};
	
	#print Dumper($PatternWeightFile);exit;
	
	if (mkdir $ClassifierDir) {
		#print "create $ClassifierDir \n";
	} else{
		#print "Dir existed: $ClassifierDir \n";
		system "rm -fr $ClassifierDir/*";
	}
	#exit;
	foreach my $OneETA (@$ETA) {
		chomp($OneETA);
		#print Dumper($OneETA);
		#print Dumper($ETAStr);exit;
		
		#$ETAStr =~ s/\./_/g;
		my $ETAClassifierDir = "$ClassifierDir\/ETA_".$OneETA;
		
		#print Dumper($ETAClassifierDir);exit;
		
		if (mkdir $ETAClassifierDir) {
			#print "create $ETAClassifierDir\n";
		} else{
			#print "Dir existed: $ETAClassifierDir\n";
			#print "rm -f $ETAClassifierDir\n"; 
			system "rm -fr $ETAClassifierDir/*";
			#exit;
		}
		
		foreach my $ClassID1 (sort keys  %{$SeqVectors}) {
			my $Centroid = {};
			my $P = {};
			my $N = {};
			my $PCnt =0;
			my $NCnt =0;
			foreach my $ClassID2 (sort keys  %{$SeqVectors}) {
				if ($ClassID1 == $ClassID2) {
					foreach my $PID (keys %{$SeqVectors->{$ClassID2}}) {
						$P->{$PID} += $SeqVectors->{$ClassID2}->{$PID};
						$Centroid->{$PID} = 0;
					}
					$PCnt += $SeqVectorCnt->{$ClassID2};
				} else {
					foreach my $PID (keys %{$SeqVectors->{$ClassID2}}) {
						$N->{$PID} += $SeqVectors->{$ClassID2}->{$PID};
						$Centroid->{$PID} = 0;
					}
					$NCnt += $SeqVectorCnt->{$ClassID2};
				} # if ($ClassID1 == $ClassID2) { 
			} # end of foreach my $ClassID2 (sort keys  %MappingClassID) {
			#print Dumper($P);exit;
			#print Dumper($PCnt);
			#print Dumper($NCnt);
			#print "$ClassID1 \n";
			foreach my $PID ( keys %{$Centroid} ) {
				#print Dumper($PID);
				if (($PCnt != 0)&&($NCnt != 0)) {
					$Centroid->{$PID} = $P->{$PID}/$PCnt - $OneETA*$N->{$PID}/$NCnt;
				} else {
					print "Error PCnt=$PCnt NCnt=$NCnt\n";exit;
				}
			}	
			#print Dumper($Centroid);exit;
			jdwangPackage::VectorNormalization($Centroid);
			
			#print Dumper($Centroid);exit;
			
			my $ClassifierFile = "$ETAClassifierDir\/C$ClassID1".".txt";
			
			open (Output,">$ClassifierFile") or die "can't open file=>$ClassifierFile ";
			print Output "#jdwang_Classifier##.". scalar localtime(time()) ."\n";
			foreach my $TrainDirs (keys %{$TestInfo->{"TrainDir"}}) {
				my $MappingFile = $TestInfo->{"TrainDir"}->{"$TrainDirs"};
				print Output "#TrainingSeqVectorDirFile##$TrainDirs $MappingFile\n";
			}
			#print Output "#TrainingSeqVectorDirFile##$TrainDirFile\n";
			print Output "#PatternWeightFile##$PatternWeightFile\n";
			print Output "#WM##$WeightingMethod\n";
			print Output "#ETA##$OneETA\n";
			print Output "#TargetID##$ClassID1\n";
			#print Output "#TotalTargetIDCnt#$ClassIDCnt\n";
			foreach my $PID ( sort keys %$Centroid ) {
				#print Dumper($PID);
				print Output "$PID ".(sprintf "%5.8f",$Centroid->{$PID})."\n";
			}
			close(Output);
		} # end of foreach my $ClassID1 (sort keys  %MappingClassID) 
	} #end of foreach 
} # end of sub CreatClassifier {
#####################################################################
# 2007.3.12
#####################################################################
sub CreatClassifierMapping {
	
	my ($TestInfo,$ETA,$SeqVectors,$SeqVectorCnt) = @_;
	
	my $ClassifierMappingDir = $TestInfo->{"ClassifiersMappingDir"};
	my $ClassifierDir =  $TestInfo->{"ClassifiersDir"};
	my $ETAFile = $TestInfo->{"ETAFile"};
	my $PatternWeightFile = $TestInfo->{"PatternsWeighting"};
	my $WeightingMethod = $TestInfo->{"WM"};
	
	
	if (mkdir $ClassifierMappingDir) {
		#print "create $ClassifierMappingDir \n";
	} else{
		#print "Dir existed: $ClassifierMappingDir \n";
	}
	my $ClassIDMapping = $ClassifierMappingDir."\/ClassifierMapping.txt";
	
	open (OutputMapping,">$ClassIDMapping") or die "can't open $ClassIDMapping\n";
	print OutputMapping "#jdwang_Classifier##.". scalar localtime(time()) ."\n";
	foreach my $TrainDirs (keys %{$TestInfo{"TrainDir"}}) {
		my $MappingFile = $TestInfo{"TrainDir"}->{"$TrainDirs"};
		print OutputMapping "#TrainingSeqVectorDirFile##$TrainDirs $MappingFile\n";
	}
	print OutputMapping "#PatternWeightFile##$PatternWeightFile\n";
	print OutputMapping "#Weighting##$WeightingMethod\n";
	foreach my $ClassID1 (sort keys  %{$SeqVectors}) { 
		print OutputMapping "$ClassID1 C$ClassID1\n";
	}
	close(OutputMapping);
}
#####################################################################
# 2007.5.15
#####################################################################
sub HashMatrixOutputFile {
	my ($OutputFile,$HashMatrix) = @_;
	
	open (output,">$OutputFile") or die "can't open $OutputFile";
	print output " #";
	foreach my $One (sort keys %$HashMatrix){
		print output "$One#";
	}
	print output "\n";
	foreach my $One (sort keys %$HashMatrix){
		print output "$One#";
		foreach my $Another (sort keys %$HashMatrix) {
			print output (sprintf "%5.5f",$HashMatrix->{$One}->{$Another})."#";
		}
		print output "\n";
	}
	close(output);
}
#####################################################################
# 2007.5.15
#####################################################################
sub LoadTypeID {
	my ($VectorIDMappingFile,$VecTypeID) = @_;
	open (input,"<$VectorIDMappingFile") or die "can't open $VectorIDMappingFile\n";
	my $cnt=0;
	while (my $line = <input> ){
		if ($line =~ /^#/) {
			#print "Comment: $line\n";
		} else {
			chomp($line);
			$cnt++;
			my @Items = split /#/,$line; 
			$VecTypeID->{$Items[1]} = $Items[0];
		}
	}
	#print Dumper($VecTypeID);exit;
	close(input);
	return($cnt);
}
#####################################################################
# 2007.6.21
#####################################################################
sub GenerateRandomStr{
	my ($RandomStrFileName,$RepeatTime,$PatternDistribution) = @_;
	#print Dumper($PatternDistribution);
	my $Str = "";
	
	foreach my $key (keys %$PatternDistribution){
		#print "$key $PatternDistribution->{$key}\n";
		for (my $i=0;$i<$PatternDistribution->{$key};++$i) {
			$Str = $Str ."$key";
		}
	}
	#print "$Str\n";
	my $StrLength=length($Str);
	#print Dumper($StrLength);
	my @Items = split //,$Str;
	#print Dumper(@Items);
	my $RepeatSample = $StrLength*$RepeatTime;
	my @NumDistribution=();
	srand;
	for (my $i=0;$i<$RepeatSample;++$i){
		my $RandomHit1 = int(rand($StrLength));
		my $RandomHit2 = int(rand($StrLength));
		#print "$RandomHit\n";
		#$NumDistribution[$RandomHit]++;
		Swap($RandomHit1,$RandomHit2,\@Items);
		#print Dumper($RandomHit);
		#exit;
	}
	#print Dumper(@NumDistribution);
	#print Dumper(@Items);
	
	my $Str = join("",@Items);
	
	open (outputfile,">$RandomStrFileName") or die "can't open $RandomStrFileName";
	print outputfile ">$RandomStrFileName\n";
	print outputfile "$Str\n";
	close(outputfile);
}
#####################################################################
# 2007.6.21
#####################################################################
sub Swap {
	my ($i,$j,$Items) = @_;
	#print "$i,$j";
	#print Dumper(@$Items);
	my $Temp = $Items->[$i];
	$Items->[$i]=$Items->[$j];
	$Items->[$j]=$Temp;
	#print Dumper(@$Items);
}

####################################################################



return 1;
